{-
% cv. 9 ; na 19.4.2017 (St) ; Jan Hric
% v. 1.1

% Obsah: cv9:
Haskell

; prejmenovat na *.hs 

-}

-- vzor
suma1 :: [Integer] -> Integer
suma1 [] = 0
suma1 (x:xs) = x + suma1 xs

length1 :: [a] -> Integer
length1 [] = 0
length1 (x:xs) = 1 + length1 xs

{-
Naprogramujte:

1. Klouzavy prumer ze 3
klPrum [1,2,3,4,2,0] -> [2.0, 3.0, 3.0, 2.0]
-}
klPrum :: [Float] -> [Float]
klPrum (x1:x2:x3:xs) = (x1+x2+x3)/3 : klPrum (x2:x3:xs)
klPrum _             = []

ta1 = klPrum [1,2,3,4,2,0]

{-
2. Klouzavy prumer ze n, pomoci div/2
klPrumN :: Int -> [Int] -> [Int]

Jak to lze zobecnit?:
-- 2a. Zobecneni: linearni transformace/konvoluce
-- linearni: zadavam koeficienty pro skalarni soucin
-- nelinearni je napr. median
-- linKonv koefs n xs = seznam vysledku lin. transformace s koeficienty
	koefs na klouzave useky z xs delky n 
linKonv :: [a] -> Int -> [a] -> [a]
volani: 
> linKonv [1/3, 1/3, 1/3] 3 [1,2,3,4,5]
pouziti, i pro definovani konkretnich transformaci:
klPrum xs = linKonv [1/3, 1/3, 1/3] 3 xs

-- 2b. Zobecneni: konvoluce
-- konv fce delka xs = 
konv :: ([a] -> b) -> Int -> [a] -> [b]

3. rychle umocnovani : expR x n = x^n
expR :: a -> Integer -> a   -- nepresne

-- zobecneni:
funkci nasobeni muzeme predavat jako parametr a nasledne nasobit, co potrebujeme

4. rychle umocnovani s modulo : expR x n m = (x^n mod m)
-- hodnoty chceme v rozsahu do m^2
expMod :: a -> Integer -> Integer -> a   -- nepresne

5. nKratF: opakovani funkce n krat
nKratF :: (a -> a) -> Int -> a -> a

-- 3. moznosti:
a) rekurze se zasobnikem, "doprava"
b) tail-rekurze s akumulatorem, "doleva"
c) deleni na poloviny, jako minule u expR

-- nestihli jsme
6. Fibonacciho cisla, pomocna fce z dvojic na dvojice
-}
--  fib n = n-te fib. cislo, n>0, indexovano od 1
fib :: Integer -> Integer
fib n = fst (fib1 n (1,0))

fib1 :: Integer -> (Integer,Integer) -> (Integer,Integer)
fib1 1  f1f0  = f1f0
fib1 n  f1f0  = fib1 (n-1) (transformujFib f1f0)

transformujFib :: (Integer,Integer) -> (Integer,Integer) 
transformujFib (f2,f1) = (f1+f2,f2)

-- co se hodi, z prelude
-- fst :: (a,b) -> a
-- fst (x,y) = x

-- muzeme pouzit fci nKratF


{-
-----------------
priste:

7. lookup1: vyhledavani klice, kdyz tam je 
lookup1 :: a -> [(a,b)] -> b

8. kartezsky soucin
kart :: [a] -> [b] -> [(a,b)]

9. test komutativity, 
co se hodi: (all :: (a-> Bool) -> [a] -> Bool)

 

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli:
% - Haskell
% - seznamy 
    - strukturalni rekurzi na seznamech
% - funkcionalni parametry
    - lambda funkce
% - pattern matching / porovnavani se vzorem


-----------------------------------------------
Z minulych let:

- klouzavy prumer ze 3
  - klouzavy prumer z n
- mergesort, sude, liche, merge
- testKomut
  - kartezsky soucin
- filter
- tridy ekv.
- lookup, zjednoduseny
- automaty (2x), reprezentace DKA vs. NKA, krok
- (rychle umocnovani)
- (FFT)

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
-}

